'''
Je maakt een eenvoudig zoekmachine voor een bedrijf (in het examen heette het Gookle, inderdaad ja.)
Hiervoor moet je enkele functies maken. Kies de datastructuur slim.

Elke webpagina bevat enkele elementen:
-de URL
-de titel van de webpagina
-de zoektermen (of *keywords*) waarmee je webpagina zou vinden
-alle links op deze webpagina (in de vorm van een lijst URLs) op die naar andere webpagina's leiden.


Er werd verwacht dat we dit deel in 2u15min maakten en dat de volgende delen zo lang zouden duren:

maak_een_lege_datastructuur & voeg_webpagina_toe : 30min
populariteit & zoek : 45min
bereikbaar : 45min

Veel succes, nieuwe eerstejaar. Yeet lit dab dab
'''




#Met deze functie wordt een nieuwe datastructuur gemaakt.
#return: de datastructuur
def maak_een_lege_datastructuur():
    return {}

#Hiermee wordt de webpagina samen met alle bijhorende elementen toegevoegd. Als de webpagina al in de datastructuur
#staat, worden de oude elementen met de nieuwe elementen vervangen.
#parameters: de datastructuur, de url (string), de titel (string), de keywords (een set van strings) en de links (een set van strings)
#return: /
def voeg_webpagina_toe(data_structuur, url, titel, keywords, links):
    data_structuur[url] = (titel,keywords,links)


#Deze functie geeft weer hoe populair een webpagina is, namelijk hoeveel andere webpagina's naar deze webpagina leiden.
def populariteit(data_structuur, url):
    populair = 0
    for pagina in data_structuur:
        if url in data_structuur[pagina][2]:
            populair +=1

    return populair


#Deze functie geeft een lijst van webpagina's weer die gegeven zoekterm (keyword) bevatten, gerandschikt
#naar populariteit. Als meerdere webpagina's even populair zijn, worden ze alfabetisch gerandschikt.
def zoek(data_structuur, keyword):
    websites = {}
    zoekresultaten = []
    for pagina in data_structuur:
        if keyword in data_structuur[pagina][1]:
            populair = populariteit(data_structuur,pagina)
            if populair not in websites:
                websites[populair] = set()
            websites[populair].add(pagina)
    for waarde in sorted(websites, reverse=True):
        zoekresultaten += sorted(websites[waarde])
    return zoekresultaten


#Deze functie bepaalt of je rechstreeks of onrechtstreeks de ene webpagina (from url) naar de ander (to url) kunt,
#door van link tot link te springen.
#De functie geeft True als het mogelijk is en False als het niet mogelijk is
def bereikbaar(data_structuur, from_url, to_url):
    if from_url not in data_structuur:
        #Als deze url niet in de data-structuur is, kun je er natuurlijk ook nergens heen gaan
        return False
    if len(data_structuur[from_url][2]) == 0:
        #Als de url naar geen enkele andere webpagina leidt, gaat het natuurlijk ook niet lukken
        return False
    if to_url in data_structuur[from_url][1]:
        #Als je rechtstreeks tussen beide pagina's kunt, lukt het natuurlijk
        return True


    #In de restgevallen moeten we controleren voor de links van from_url
    copylist = data_structuur.copy()
    copylist.pop(from_url)
    waar = False
    for page in data_structuur[from_url][2]:
        waar = bereikbaar(copylist,page,to_url)
        if waar:
            return True
    return waar

'''
Dit is de oplossing die ik heb gemaakt op de dag van het examen. Aangezien ik mijn punten nog niet weet
kan ik niet met 100% zekerheid zeggen of ik gelijk had. Deze code slaagde wel voor alle testen van het test-
programma op het examen.

EDIT: Ik heb een 17/20 blijkbaar gehaald dus ja
'''