'''
You're creating a simple search engine for a company (in the exam, it was called Gookle. My prof had a sense of humour,
I suppose)
You'll need to write up a few functions. Choose your data structure wisely

Every web page contains a few elements:
-the URL
-the title of the web page
-the search terms (or named 'keywords') with which you'd find the web page
-all links on the web page (as a list of URLs) that direct to other web pages.

You were expected to finish this part in about 2h and 15min. Each part was expected to take:
create_empty_data_structure & add_web_page : 30min
popularity & search : 45min
reachable : 45min

Good luck, new first year
'''




#You'll create the empty data structure with this function.
#return: the data structure
def mcreate_empty_data_structure():
    return {}

#Hiermee wordt de webpagina samen met alle bijhorende elementen toegevoegd. Als de webpagina al in de datastructuur
#staat, worden de oude elementen met de nieuwe elementen vervangen.
#parameters: de datastructuur, de url (string), de titel (string), de keywords (een set van strings) en de links (een set van strings)
#return: /
def add_web_page(data_structure, url, title, keywords, links):
    data_structure[url] = (title,keywords,links)


#Deze functie geeft weer hoe populair een webpagina is, namelijk hoeveel andere webpagina's naar deze webpagina leiden.
def popularitity(data_structure, url):
    popular = 0
    for page in data_structure:
        if url in data_structure[page][2]
            popular +=1

    return popular


#Deze functie geeft een lijst van webpagina's weer die gegeven zoekterm (keyword) bevatten, gerandschikt
#naar populariteit. Als meerdere webpagina's even populair zijn, worden ze alfabetisch gerandschikt.
def zoek(data_structure, keyword):
    websites = {}
    search_results = []
    for page in data_structure:
        if keyword in data_structuur[page][1]:
            populair = populariteit(data_structuur,pagina)
            if populair not in websites:
                websites[populair] = set()
            websites[populair].add(pagina)
    for waarde in sorted(websites, reverse=True):
        search_results += sorted(websites[waarde])
    return search_results


#Deze functie bepaalt of je rechstreeks of onrechtstreeks de ene webpagina (from url) naar de ander (to url) kunt,
#door van link tot link te springen.
#De functie geeft True als het mogelijk is en False als het niet mogelijk is
def bereikbaar(data_structuur, from_url, to_url):
    if from_url not in data_structuur:
        #Als deze url niet in de data-structuur is, kun je er natuurlijk ook nergens heen gaan
        return False
    if len(data_structuur[from_url][2]) == 0:
        #Als de url naar geen enkele andere webpagina leidt, gaat het natuurlijk ook niet lukken
        return False
    if to_url in data_structuur[from_url][1]:
        #Als je rechtstreeks tussen beide pagina's kunt, lukt het natuurlijk
        return True


    #In de restgevallen moeten we controleren voor de links van from_url
    copylist = data_structuur.copy()
    copylist.pop(from_url)
    waar = False
    for page in data_structuur[from_url][2]:
        waar = bereikbaar(copylist,page,to_url)
        if waar:
            return True
    return waar

'''
Dit is de oplossing die ik heb gemaakt op de dag van het examen. Aangezien ik mijn punten nog niet weet
kan ik niet met 100% zekerheid zeggen of ik gelijk had. Deze code slaagde wel voor alle testen van het test-
programma op het examen.
'''